/*
 * CREDITS: this example is based on material developed for the
 * Introduction to Programming course by Nimi Berman and Cay Horstmann
 * at San Jose State University, CA.
 *
 * The original material can be found at:
 *    www.cs.sjsu.edu/faculty/horstman/CS46A/debugger/tutorial.html
 */
package wordanalyzer;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

public class WordAnalyzerTest {

    // Test fixture
    private WordAnalyzer wa;

    public WordAnalyzerTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        wa = new WordAnalyzer();
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of firstRepeatedCharacter method, of class WordAnalyzer.
     */
    @Test
    public void testFirstRepeatedCharacter() {
        wa.setWord("");
        assertEquals(0, wa.firstRepeatedCharacter());

        wa.setWord("aardvark");
        assertEquals('a', wa.firstRepeatedCharacter());

        wa.setWord("roommate");
        assertEquals('o', wa.firstRepeatedCharacter());

        wa.setWord("mate");
        assertEquals(0, wa.firstRepeatedCharacter());

        wa.setWord("test");
        assertEquals(0, wa.firstRepeatedCharacter());
    }

    /**
     * Test of firstMultipleCharacter method, of class WordAnalyzer.
     */
    @Test
    public void testFirstMultipleCharacter() {
        wa.setWord("");
        assertEquals(0, wa.firstMultipleCharacter());

        wa.setWord("missisippi");
        assertEquals('i', wa.firstMultipleCharacter());

        wa.setWord("mate");
        assertEquals(0, wa.firstMultipleCharacter());

        wa.setWord("test");
        assertEquals('t', wa.firstMultipleCharacter());
    }

    /**
     * Test of countRepeatedCharacters method, of class WordAnalyzer.
     */
    @Test
    public void testCountRepeatedCharacters() {
        wa.setWord("");
        assertEquals(0, wa.countRepeatedCharacters());

        wa.setWord("mississippiii");
        assertEquals(4, wa.countRepeatedCharacters());

        wa.setWord("test");
        assertEquals(0, wa.countRepeatedCharacters());

        wa.setWord("aabbcdaaaabb");
        assertEquals(4, wa.countRepeatedCharacters());
    }

    /**
     * Test of setWord method, of class WordAnalyzer.
     */
    @Test(expected = IllegalArgumentException.class)
    public void testSetWordException() {
        wa.setWord(null);
    }

    /**
     * Test of isPalindrome method, of class WordAnalyzer.
     */
    @Test
    public void testIsPalindrome() {
        wa.setWord("");
        assertTrue(wa.isPalindrome());

        wa.setWord("a");
        assertTrue(wa.isPalindrome());

        wa.setWord("ab");
        assertFalse(wa.isPalindrome());

        wa.setWord("aa");
        assertTrue(wa.isPalindrome());

        wa.setWord("baab");
        assertTrue(wa.isPalindrome());

        wa.setWord("bacab");
        assertTrue(wa.isPalindrome());

        wa.setWord("bacdab");
        assertFalse(wa.isPalindrome());
    }
}
